//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//
//  search zeros of zeta function
//
//  c.f.    ݥޥͽ 3 ɾ 1991
//
#include "Fint.hpp"
#include "Complex.hpp"
#include <fstream.h>
#ifdef WIN32
#include <conio.h>

#ifdef __BORLANDC__
#  include <constrea.h>
#  include <classlib\StdTempl.h>
#  pragma option -Jg
#else
   int wherex(void) ;
   int wherey(void) ;
   void clrscr(void) ;
   void gotoxy(int x,int y) ;
#  include  <memory.h>
#  include <stdlib.h>
#endif
#endif
#include "Error.hpp"

void SetBernoulliTable(Mint* B) ;
void SearchZero(Fint t,Fint tstep,int sgn1) ;
Fint theta(Fint& t) ;
Complex zeta(Complex& s) ;
Mint factorial(unsigned long n) ;

Mint* B ;
int maxBern=60 ;

Fint th ;
Fint eps(1) ;
unsigned long zeros=0 ;
Fint thetaErr ;
Fint ZetaErr ;
#ifdef __BORLANDC__
constream con ;
#endif
int nline=23 ;
int l=1 ;
unsigned long nZeta=0 ;

int main(void)
{
  SetPrecision(1) ;
  SetFormat(noSpace) ;
  eps[1-eps.fdigit()] ;                // ʲ 1ˤ
  eps >>=(32*(eps.fdigit()-1)+10) ;
#ifdef WIN32
#ifdef __BORLANDC__
  con.clrscr() ;
  con.window(1,1,80,nline) ;
#else
  clrscr() ;
#endif
#endif

  B=new Mint[maxBern+1] ;
  SetBernoulliTable(B) ;
  Complex s,z ;
  Fint t(13) ;
  Fint tstep ;
  unsigned long nZero=10 ;

  (tstep=1) /= 5 ;     // tstep=0.2 ;
  int sgn1=0 ;
  int sgn2 ;
  (real(s)=1)>>=1  ;
  cout << endl << " Input number of zeros " ;
  cin >> nZero ;
#ifdef __BORLANDC__
  con.clrscr() ;
#else
  clrscr() ;
#endif
  for( ; !kbhit() ; ) {

    imag(s)=t ;
    th=theta(t) ;
    real(z)=cos(th) ;
    imag(z)=sin(th) ;
    z *= zeta(s) ;
    sgn2=sign(real(z)) ;
#ifdef __BORLANDC__
con.rdbuf()->gotoxy(1,l) ;
#else
gotoxy(1,l) ;
#endif
//con << t << z << " " << ZetaErr << " " << thetaErr ;
    if( sgn1*sgn2<0 ) {
//con.rdbuf()->delline() ;
      SearchZero(t,tstep,sgn2) ;
      if( --nZero==0 ) break ;
    }
    sgn1=sgn2 ;
    t += tstep ;
  }

  delete [] B ;
  return 0 ;
}

void SearchZero(Fint t,Fint tstep,int sgn1)
{
  int sgn2 ;
  static Complex s,e ;
#ifdef __BORLANDC__
con.rdbuf()->gotoxy(1,l) ;
con.rdbuf()->delline() ;
//con << " search zero ....." ;
#else
gotoxy(1,l) ;
//cout << " search zero ...." ;
#endif
  tstep /= (-2) ;
  (real(s)=1)>>=1 ;

  while( tstep!=0 )  {
    t += tstep ;
    imag(s)=t ;

    th=theta(t) ;
    real(e)=cos(th) ;
    imag(e)=sin(th) ;
    sgn2=sign(real(zeta(s)*e)) ;
    if( sgn1==sgn2) {
      tstep>>=1L ;
    }
    else {
      tstep /= (-2) ;
      sgn1=sgn2 ;
    }
  }
  zeros++ ;
#ifdef __BORLANDC__
con.rdbuf()->gotoxy(1,l) ;
con.rdbuf()->delline() ;
con << "found " << s << " zeta " << zeta(s) << " " << ++nZeta;
//       << " #zeros  " << zeros << endl ;
#else
gotoxy(1,l) ;
cout << "found " << s << " zeta " << zeta(s) <<
" " << ++nZeta << endl << flush ;
//       << " #zeros  " << zeros << endl ;
#endif
  l++ ;
  if( l>nline ) {
    l=nline ;
#ifdef __BORLANDC__
    con << endl ;
    con.rdbuf()->gotoxy(1,l) ;
#else
    cout << endl ;
    gotoxy(1,l) ;
#endif
  }
}

// (t)=arg(1/4+it/2)-tlog()/2
Fint theta(Fint& t)
{
//  thetaErr=2/power(t,Mint(5)) ;
  thetaErr=t*t ;
  (thetaErr *= thetaErr ) *= t ;
  thetaErr=1/thetaErr ;
  return t*log(t/(2*pi()))/2-t/2-pi()/8+1/(48*t)+7/(5760*t*t*t) ;
}


Complex zeta(Complex& s)
{
  long j ;
  long n ;
  Mint ni ;
  static Complex ms ;
  ms=-s ;


//cout << endl << "eps " << eps ;
//  Fint Err ;
  static Complex w ;
  w=1 ;
  static Complex z,ns,prod ;
  z=0 ;
  for( j=1 ; j<=maxBern-4 ; j++ ) real(w) *= (1+abs(s+j)) ;
  real(w)=B[maxBern-5]*real(w)/(factorial(maxBern-4)*B[maxBern-4]*eps) ;
  n=2+(int)(long)Int( (exp(log(real(w))/(real(s)+maxBern-5)))) ;
  n=32767>n? n:32767 ;
//  n=min(32767,2+(int)(long)Int( (exp(log(real(w))/(real(s)+maxBern-5)))) ) ;
  for( j=1 ; j<n ; j++ ) z += power(Mint(j),ms) ;

  ns=power(Mint(n),ms) ;
  z += (n*ns/(s-1)) ;
  z += (ns/2) ;

  prod=s ;

  ni=n*2 ;
  j=1 ;
  ZetaErr=1 ;
  w=(prod*ns*B[j])/(ni*B[j+1]) ;
  do {
    z += w ;
    prod *= (s+j)*(s+j+1) ;
    ni *= (n*n)*(j+3)*(-j-2) ;
    j += 2 ;
    w=(prod*ns*B[j])/(ni*B[j+1]) ;
    if( -j<real(s) ) ZetaErr=abs(w)*abs((s+j)/(real(s)+j)) ;
  } while( ZetaErr>=eps && j<=maxBern-2) ;

  return z ;

}

void SetBernoulliTable(Mint* B)
{
                                      // Bernoulli  table
  char filename[]=".\\bernoull.tbl" ;
  ifstream inf(filename,ios::binary) ;     // binary file
  if( inf.bad() ) {
    cerr << endl << "Error : could not open file " << filename ;
    Error(file not found) ;
  }

  int j ;
  long k ;

                                          // Bernoulliɤ߹
  inf.read((char*)&k,sizeof(k)) ;       // BernoulliθĿ
  read(inf,B[0]) ;                        // B0 ɤߤȤФ
  read(inf,B[0]) ;
  j=1 ;
  for( k=1 ; k<=maxBern/2 ; k++ ) {
    read(inf,B[j]) ;                       // Bernoulli ʬ
    read(inf,B[j+1]) ;                     // Bernoulli ʬ
    j += 2 ;
  }
  inf.close() ;
}
