//
//      Copyright (C) by S.Tomabechi 2001
//      All rights reserved.
//
//      represent an odd prime by sum of four squares (Euler)
//

#include "Mint.hpp"
#include "Error.hpp"
bool lemma2(Mint& p,Mint& x,Mint& y,Mint& z,Mint& t,Mint& k) ;
bool lemma3(Mint& p,Mint& x,Mint& y,Mint& z,Mint& t,Mint& k) ;

bool lemma(Mint& p,Mint& x,Mint& y,Mint& z,Mint& t,Mint& k)
{
    if( p<0 ) return false ;
    else if( (long(p)&3)!=3 ) return false ;
    if( prmdiv(p)!=1 ) return false ;

    Mint d=2 ;
    for(;;) {
        if( Kronecker(d,p)==-1 ) break ;
        else ++d ;
    }
    x=sqrt(d-1,p) ;
    y=sqrt(p-d,p) ;
//  z=sqrt(p-1,p) ;
    z=1 ;
//  Mint t ;
    t=x*x+y*y+z*z ;
    cout << endl << "x y z " << x << " " << y << " " << z ;
    cout << endl << "x^2 y^2 z^2 " << x*x << " " << y*y << " " << z*z ;
    k=t/p ;
    cout << endl << "t  " << t << " " << mod(t,p) << " mod  " << p << " k " << k;
    t=0 ;

Mint w ;
    for(; k!=1 ;) {
    w=x*x+y*y+z*z+t*t ;
    if( w!=k*p ) Error( w!=k*p) ;
cout << endl << "k p w " << k << " " << p << " " << w ;
        if( mod(k,2)==0 ) lemma2(p,x,y,z,t,k) ;
        else lemma3(p,x,y,z,t,k) ;

    }
//  cout << endl << "x y z t " << x << " " << y << " " << z << " " << t ;
//  cout << endl << "x^2 y^2 z^2 t^2 " << x*x << " " << y*y << " " << z*z << " " << t*t ;
//  cout << endl << "w " << w << " " << mod(w,p) << " mod  " << p << " k " << k ;
//  cout << endl << "post lemma 2 " << k ;
    return true ;


}


bool lemma2(Mint& p,Mint& x,Mint& y,Mint& z,Mint& t,Mint& k)
{
    Mint w ;
    if( (long(k)&1)==0 ) {
        if( mod(x-y,2)==0 ) {
            ;
        }
        else {
            Swap(y,z) ;
            if( mod(x-y,2)==0 ) {
                ;
            }
            else {
                Swap(y,t) ;
            }
        }
        k/=2 ;
        x=(x+y)/2 ;
//      x=w ;
        y=x-y ;

        z=(z+t)/2 ;
        t=z-t ;

        w=x*x+y*y+z*z+t*t ;
//      cout << endl << "x y z t " << x << " " << y << " " << z << " " << t ;
//      cout << endl << "x^2 y^2 z^2 t^2 " << x*x << " " << y*y << " " << z*z << " " << t*t ;
//      cout << endl << "w " << w << " " << mod(w,p) << " mod  " << p << " k " << k ;
        cout << endl << "post lemma 2 " << k ;
        if( w!=(k*p) ) Error(ajajdsasd) ;
        if( mod(w,p)!=0 ) Error(aaa) ;
    }

}

bool lemma3(Mint& p,Mint& x,Mint& y,Mint& z,Mint& t,Mint& k)
{
    Mint w ;
    Mint X,Y,Z,T ;
    Mint x1,y1,z1,t1 ;
    Mint l ;
    if( (long(k)&1)==0 ) return false ;

    x1=amod(x,k) ;                      // |x1|<|k|/2
    y1=amod(y,k) ;
    z1=amod(z,k) ;
    t1=amod(t,k) ;

    w=x1*x1+y1*y1+z1*z1+t1*t1 ;         //  w<=4*|k|^2/4

    cout << endl << "x y z t " << x << " " << y << " " << z << " " << t ;
    cout << endl << "    " << x1 << " " << y1 << "  " << z1 << " " << t1 ;
//  cout << endl << "sum (^2    ) "   << w ;

//  cout << endl << " w " << w ;
//  cout << endl << " w mod k " << mod(w,k) ;

    l=w/k ;
    if( l==0 ) return true ;


//  cout << endl << " k l " << k << " " << l ;
    X=(x*x1+y*y1+z*z1+t*t1) ;
cout << endl << " X " << X ;
if( mod(X,k)!=0 ) Error(mod(X,k)!=0) ;
    Y=(x*y1-y*x1-z*t1+t*z1) ;
Mint a1=x*y1 ;
Mint b1=y*z1 ;
Mint c1=z*t1 ;
Mint d1=t*x1 ;
cout << endl << " " << a1 << " " << b1 << " " << c1 << " " << d1 ;
a1=a1+b1 ;
cout << endl << a1 ;
cout << endl << x*y1 ;
cout << endl << (-y*x1) ;
cout << endl << (-z*t1) ;
cout << endl << t*x1 ;
cout << endl << (x*y1-y*x1) ;
cout << endl << (x*y1-y*z1-z*t1+t*x1) ;
cout << endl << (x*y1-(y*z1)-(z*t1)+(t*x1)) ;
cout << endl << " Y " << Y ;
if( mod(Y,k)!=0 ) Error(mod(Y,k)!=0) ;
    Z=(x*z1+y*t1-z*x1-t*y1) ;
cout << endl << " Z " << Z ;
if( mod(Z,k)!=0 ) Error(mod(Z,k)!=0) ;
    T=(x*t1-y*z1+z*y1-t*x1) ;
cout << endl << " T " << T ;
if( mod(T,k)!=0 ) Error(mod(T,k)!=0) ;
cout << endl << "X Y Z T " << X << " " << Y << " " << Z << " " << T ;
//Y=p ;

    x=X/k ;
    y=Y/k ;
    z=Z/k ;
    t=T/k ;
    k=l ;

w=x*x+y*y+z*z+t*t ;
//  cout << endl << "lemma 3" ;
//  cout << endl << "x y z t " << x << " " << y << " " << z << " " << t ;
//  cout << endl << "x^2 y^2 z^2 t^2 " << x*x << " " << y*y << " " << z*z << " " << t*t ;
//  cout << endl << "w " << w << " " << mod(w,p) << " mod  " << p << " k " << k ;
cout << endl << "k p w " << k << " " << p << " " << w ;
    cout << endl << "post lemma 3 " << k ;
    if( w!=(k*p) ) Error(bbbbbbbasd) ;
    if( mod(w,p)!=0 ) Error(bbb) ;
    return true ;


}



#include <stdlib.h>

int main(void)
{
    unsigned long p ;
    Mint P ;
    Mint x,y,z,k,t ;

    for( ; ; ) {
        cout << "input a number " ;
        cin >> p ;
        if( p==0 ) break ;
        p=nextprm(p) ;
        P=p ;
        for(;;) {
            if( lemma(P,x,y,z,t,k) ) {
                cout << endl << P << " " << x*x << " + " << y*y <<" + " <<  z*z << " +  " << t*t ;
                break ;
            }
            else cout << endl << "failed " ;
            P+=2 ;
        }
    }
    return 1 ;

}
