//
//  Copyright (C) by S.Tomabechi 1993-1996
//  All rights reserved
//
#ifndef __INTFUNCS_HPP
#define __INTFUNCS_HPP

extern const long _Kr_tab[] ;
extern unsigned long random_seed ;
unsigned long gcd(const unsigned long a,const unsigned long b) ;
unsigned long gcd(const long a,const unsigned long b) ;
long gcd(const long a,const long b) ;
long gcd(const long a,const int b) ;
long gcd(const int a,const long b) ;
long gcd(const int a,const int b) ;
unsigned long gcd(const unsigned long a,const int b) ;


//#define SMALL_DIVISOR (0x00100000UL)   // оݤȤʤĶˤä
                                         // ѹ褤

//#define SMALL_DIVISOR (1076143UL)
#define SMALL_DIVISOR (2160553UL)
//d#define SMALL_DIVISOR (149163283UL)
void divide(const long a,const long b,long& q,long& r) ;
void divide(const unsigned long a,const unsigned long b,
            unsigned long& q,unsigned long& r) ;

long BitScanReverse(const unsigned long n) ;
short  BitScanReverse(const unsigned short  n) ;

// a+b mod p
unsigned long isAdd(const unsigned long a,const unsigned long b,const unsigned long p) ;
// a-b mod p
unsigned long isSub(const unsigned long a,const unsigned long b,const unsigned long p) ;
// a*b mod p
unsigned long isMul(const unsigned long a,const unsigned long b,const unsigned long p) ;
// a/b mod p     gcd(b,p) must be 1
unsigned long isDiv(const unsigned long a,const unsigned long b,const unsigned long p) ;
long egcd(const long a,const long b,long& u,long& v) ;

long ilog2(const unsigned long n) ;
long mod(const long n,const long p) ;
long mod(const long n,const int  p) ;
unsigned long mod(const unsigned long n,const unsigned long p) ;

long mod(const long n,const short p) ;
long mod(const long a,const long b,const long p) ; // mod(a*b,p)
unsigned long mod(const unsigned long a,const unsigned long b,const unsigned long p) ; // mod(a*b,p)

unsigned long mod(const long a,const unsigned long b) ;




long amod(const long n,const long p) ;
long amod(const unsigned long,const unsigned long p) ;
long invmodp(const long a,const long b) ;                    // a^-1 mod p
unsigned long invmodp(const unsigned long a,const unsigned long p) ;  // a^-1 mod p
unsigned long invmodp(const long a,const unsigned long p) ;                   // a^-1 mod p
unsigned long irandom(unsigned long& seed=random_seed) ;
float frandom(unsigned long& seed) ;
double drandom(unsigned long& seed) ;
unsigned long isqrt(const unsigned long n0,const unsigned long n1=0) ;
long Kronecker(const long a,const long b) ;
long Kronecker(const unsigned long a,const unsigned long b) ;
int Moebius(unsigned long n) ;
unsigned long power(const unsigned long x,const unsigned long n,const unsigned long p) ;
unsigned long power(const long x,const unsigned long n,const unsigned long p) ;
unsigned long power(const long x,const long n,const unsigned  long p) ;
unsigned long power(const long x,const unsigned long n,const long p) ;
unsigned long power(const long x,const long n,const long p) ;
unsigned long power(const int x,const unsigned long n,const unsigned long p) ;
inline unsigned long power(const long x,const unsigned long n,const unsigned long p)
{
    return power(mod(x,p),n,p) ;
}

inline unsigned long power(const long x,const unsigned long n,const long p)
{
    return power(x,n,(unsigned long)(p>0 ? p:-p)) ;
}

inline unsigned long power(const long x,const long n,const unsigned long p)
{
  return n>=0 ?
    power(x,(unsigned long)n,p):power(invmodp(x,p),(unsigned long)(-n),p) ;
}

inline unsigned long power(const long x,const long n,const long p)
{
  return n>=0 ?
    power(x,(unsigned long)n,p):power(invmodp(x,p),(unsigned long)(-n),p) ;
}


inline unsigned long power(const int x,const long n,const unsigned long p)
{
    return power(long(x),n,p) ;
//  return n>=0 ?
//    power(x,(unsigned long)n,p):power(invmodp(x,p),(unsigned long)(-n),p) ;
}
unsigned long prm(const unsigned long n) ;
unsigned long prmdiv(const unsigned long n) ;
unsigned long prmdiv2(const unsigned long n1,const unsigned long n0,const unsigned long d=SMALL_DIVISOR) ;
unsigned long prmdiv(const long n) ;
unsigned long prmroot(const unsigned long p) ;
unsigned long prmrootp(const unsigned long p) ;
unsigned long nextprm(const unsigned long n) ;

// square root mod p
long sqrt(const long n,const long p) ;
// square root mod p
unsigned long sqrt(const unsigned long n,const unsigned long p) ;


inline unsigned long nxtprm(const unsigned long n)
{
  return nextprm(n) ;
}
unsigned long eulerphi(const unsigned long n) ;

inline long ilog2(const long n)
{
  return n>=0 ? ilog2((unsigned long)n):ilog2((unsigned long)(-n)) ;
}

inline long ilog2(const unsigned long n)
{
  return BitScanReverse(n) ;
}

inline long ilog2(const short n)
{
  return n>=0 ? ilog2((unsigned long)n):ilog2((unsigned long)(-n)) ;
}

inline long ilog2(const int n)
{
  return n>=0 ? ilog2((unsigned long)n):ilog2((unsigned long)(-n)) ;
}

inline long ilog2(const unsigned short n)
{
  return BitScanReverse((unsigned long)n) ;
}

inline unsigned long invmodp(const long a,const unsigned long p)
{
  return invmodp(mod(a,p),p) ;
}



inline Kronecker(const long a,const unsigned long b)
{
  return Kronecker(mod(a,b),b) ;
}

inline long len(const long n)
{
  return ilog2(n)+1 ;
}

inline long mod(const long n,const short p)
{
  return mod(n,long(p)) ;
}

inline long mod(const long n,const int p)
{
  return mod(n,long(p)) ;
}


inline unsigned long mod(const int n,const unsigned long p)
{
  return mod(long(n),p) ;
}

inline unsigned long mod(const unsigned long n,const unsigned long p)
{
  return n%p ;
}

inline unsigned long isMul(const unsigned long a,const unsigned long b,const unsigned long p)
{
  return mod(a,b,p) ;
}

inline unsigned long isDiv(const unsigned long a,const unsigned long b,const unsigned long p)
{
  return mod(a,invmodp(b,p),p) ;
}


///////////////////////
//
// the greatest common divisor
//
inline unsigned long gcd(const long n,const unsigned long p)
{
  return gcd((unsigned long)(n>0 ? n:-n),p) ;
}

inline long gcd(const long n,const int p)
{
  return gcd(n,long(p)) ;
}
inline long gcd(const int a,const int b)
{
  return gcd(long(a),long(b)) ;
}

inline unsigned long gcd(const unsigned long n,const int p)
{
  return p>0 ? gcd(n,(unsigned long)p):gcd(n,(unsigned long)(-p)) ;
}

inline long gcd(const int n,const long p)
{
  return gcd(long(n),p) ;
}

//inline long gcd(const long p,const int n)
//{
//  return gcd(n,p) ;
//}


//////////////////////
//
//  return the smallest divisor
//
inline unsigned long prmdiv(const long n)
{
  return prmdiv((const unsigned long)(n>0 ? n:-n)) ;
}


// Euler criterion with base 2
inline bool EulerCriterion2(unsigned long n)
{
  return amod(power(2UL,(n-1)>>1,n),n)==_Kr_tab[n&7] ;
}


//  Partition-exchange sort ( so called quick-sort )

void QSortL2A(const long size,const long length,
              const long pos,const long pos2,long* record) ;
void QSortLA(const long size,const long length,
             const long pos,long* record) ;
void QSortLD(const long size,const long length,
             const long pos,long* record) ;
void QSortUL2A(const long size,const long length,
                const long pos,const long pos2,unsigned long* record) ;
void QSortUL4A(const long size,const long length,
                const long pos,const long pos2,
                const long pos3,const long pos4,
                unsigned long* record) ;
void QSortULA(const long size,const long length,
             const long pos,unsigned long* record) ;
void QSortULD(const long size,const long length,
             const long pos,unsigned long* record) ;
void QSortUSA(const long size,const long length,
                            const long pos,unsigned short* record) ;
void QSortUSD(const long size,const long length,
                            const long pos,unsigned short* record) ;

void Gauss(unsigned long** M,long lRow,long lCol,long BitSize,unsigned long* ipiv) ;
long searchTable_byValue(const unsigned long value) ;
#endif

