//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//                        _
//  absolute value sqrt(a*a)
//
#include "Complex.hpp"

Fint abs(const Complex& c)
{
  Fint s(c.re),t(c.im) ;
  if( sign(s)<0 ) ~s ;                  // s=-s
  if( sign(t)<0 ) ~t ;                  // t=-t
  if( s<t ) Swap(s,t) ;
  if( t==0 ) return s ;
  else {
    s/=t ;                              // for keeping precision
    return t*sqrt(1+s*s) ;              // better than calculating as sqrt(s*s+t*t)
  }
}
