//
//	Cpyright (C) by S.Tomabechi 2000
//	All rights reserved.
//
//	Factorization by Number Field Sieve
//
//	Thanks to Prof. Yuji KIDA
//

//#include <vector>
//#include <algorithm>
#include <stdlib.h>
//#include <math.h>
//#ifdef __BORLANDC__
//# include <complex.h>
//#else
//# include <complex>
//#endif

#include <io.h>

#include "Mint.hpp"
//#include "Fint.hpp"
#include "Fp.hpp"
#include "PolyFp.hpp"
#include "PolyL.hpp"
#include "PolyM.hpp"
#include "Error.hpp"
#include "LBit.hpp"
#include "CPUTime.hpp"
#include <fstream.h>
#include <stdio.h>

#ifdef __BORLANDC__
#	 include <constrea.h>
#	 include <conio.h>
#	 pragma option -Jg
#else
	 int wherex(void) ;
	 int wherey(void) ;
	 void clrscr(void) ;
	 void gotoxy(int x,int y) ;
#	 include <conio.h>
#	 include <memory.h>
#	 include <stdlib.h>
#endif
#ifdef __BORLANDC__
constream con ;
#endif
int	 posx ;
int	 posx2;
int	 posx3;
int	 posy ;
int	 posy1=0 ;
int	 posy2=0 ;
int	 posy3=0 ;
int	 posy4=0 ;


unsigned long LcF ;		// leading coefficient of a polynomial
long nLcFPrimes ;		 // number of primes which divide LcF
Mint LpvLimYR ;
Mint LpvLimYA ;
unsigned long LpvLimR ;
Mint LpvLimR2 ;
unsigned long LpvLimA ;
unsigned long PmaxA ;
unsigned long PmaxA4 ;
unsigned long PmaxR ;
unsigned long PmaxR4 ;
long _nResult ;
long _nResultA ;
unsigned long _p1,_p2 ;
unsigned long Rr1,Rr2 ;
unsigned long Ra1,Ra2 ;
Mint Upper2 ;
unsigned long PmaxR2[2] ;
unsigned long PmaxA2[2] ;
unsigned long LmaxR2[2] ;
unsigned long LmaxA2[2] ;
unsigned long SieveUnit ;
unsigned long SieveUnitnow ;
unsigned long SieveWidth ;
unsigned long SieveWidthnow ;
Mint LpvLimA2 ;


//	work files

static char nfsrfb[]="./NFS-RFB.NFS" ;
static fstream nfs_rfb ;


static char nfsafb[]="./NFS-AFB.NFS" ;
static fstream nfs_afb ;

static char nfsff[]="./NFS-FF.NFS" ;
static fstream nfs_ff ;

static char nfsfp[]="./NFS-FP.NFS" ;
static fstream nfs_fp ;

static char nfspf[]="./NFS-PF.NFS" ;
static fstream nfs_pf ;

static char nfsppf[]="./NFS-PPF.NFS" ;
static fstream nfs_ppf ;

static char nfsfpp[]="./NFS-FPP.NFS" ;
static fstream nfs_fpp ;

static char nfspp_p[]="./NFS-PP-P.NFS" ;
static fstream nfs_pp_p ;

static char nfsp_pp[]="./NFS-P-PP.NFS" ;
static fstream nfs_p_pp ;

static char nfspppp[]="./NFS-PPPP.NFS" ;
static fstream nfs_pppp ;

static char nfspp[]="./NFS-PP.NFS" ;
static fstream nfs_pp ;

static char nfsdat[]="./NFS-DAT.IN" ;
static fstream nfs_dat ;


Mint Norm(long A,unsigned long B,PolyL& fL) ;
Mint Norm(long A,unsigned long B,PolyM& f) ;
Mint Norm(Mint& A,unsigned long B,PolyM& f) ;
Mint Norm(Mint* a,PolyM& G) ;
Mint NormBig(long A,unsigned long B,PolyL& fL) ;
Mint NormBig(long A,unsigned long B,PolyM& fL) ;

// Set algebraic primes

//long CountFreeRelations(unsigned long PmaxR) ;
void SetAlgebraicPrimes(PolyL& fL,unsigned long& SZA,unsigned long& SZL,unsigned long& SZC) ;
void SetAlgebraicPrimes(unsigned long maxP,PolyL& fL,unsigned long& SZA,unsigned long& SZL,unsigned long& SZC) ;
void SetAlgebraicPrimes(PolyL& fL,unsigned long& SZA,unsigned long& SZC,unsigned long& SZN) ;
void SetRationalPrimes(unsigned long SZR,unsigned long& PmaxR) ;
void SetRationalPrimes2(unsigned long& SZR,unsigned long*& Primes) ;
void SetNFB(unsigned long SZN,unsigned long* Pimes) ;
void SetAlgebraicPrimes2(unsigned long SZA,unsigned long SZC,double Scale) ;
void SetAlgebraicPrimes2(unsigned long& SZA,unsigned long& SZC,unsigned long*& PrimesA,unsigned long*& RootA);
//void SetCharacters(unsigned long& SZC,unsigned long* PrimesC,unsigned long* RootC) ;


bool BitDecompR(long nPrimesR,Mint& ABM) ;
//void DivideByBaseR(unsigned long nPrimes,unsigned long* PrimesR,long A);
bool BitDecompR(long nPrimesR,unsigned long* PrimesR,Mint& ABM,unsigned long* v2) ;
bool BitDecompA(long nPrimesA,long A,unsigned long B,Mint& norm) ;
bool BitDecompA(long nPrimesA,unsigned long* PrimesA,unsigned long* RootA,
			long A,unsigned long B,Mint& norm,unsigned long* v2) ;
bool BitDecompC(long nPrimesC,long A,unsigned long B) ;
bool BitDecompC(unsigned long SZA,unsigned long nPrimesC,unsigned long* PrimesA,unsigned long* RootA,
				long A,unsigned long B,unsigned long* v2);



void CheckData(unsigned long SZR,unsigned long SZA,
				unsigned long* PrimesR,
				unsigned long* PrimesA,
				unsigned long* RootA) ;
void CheckData(ifstream& is,Mint& M,
				unsigned long SZR,unsigned long SZA,
				unsigned long LpvLimR,unsigned long LpvLimA,
				unsigned long* PrimesR,
				unsigned long* PrimesA,
				unsigned long* RootA) ;
int PrimeDecompR(long nPrimes,unsigned long* Primes,
				unsigned long* index,Mint& q) ;
#if 0
int PrimeDecomp(long nPrimes,unsigned long* Primes,
				unsigned long* index,Mint& q) ;
#endif

int PrimeDecompA(long nPrimes,unsigned long* Primes,unsigned long* Root,
				long A,unsigned long B,
				unsigned long* index,Mint q) ;

#if 0
int PrimeDecompAA(long nPrimes,unsigned long* Primes,unsigned long* Root,
				long A,unsigned long B,
				unsigned long* index,Mint& q) ;
#endif

//using namespace std ;





unsigned long Maxlim=(0xFFFFFFFF-1000000UL) ;//max of LPV and start of character


#ifdef __SNFS__
PolyL fL ;
#else
PolyM fL ;
#endif

Mint M ;
unsigned long SZR,SZA,SZC,SZN,SZL ;
//unsigned long denseColumn ;
long A ;
unsigned long B ;
//Mint* alpha=NULL ;

Mint _fx ;

void main(int argc,char* argv[])
{
	Mint N ;
	unsigned long nSieveOdd,nSieveEven ;
	unsigned long* PrimesR ;
	unsigned long* PrimesA ;
	unsigned long* RootA ;

	unsigned long nFF,nPF,nFP,nPP,nPPF,nFailsR,nFailsA ;
	unsigned long nFPP,nP_PP,nPP_P,nPPPP ;
	ifstream is ;

	unsigned long Ha,Hb ;
//	unsigned long LPodd,LPeven ;
//	double Scale ;
	char filename[256] ;
	unsigned long Bstart,Bend ;

	if( argc<2 ) ;
	else {
		sprintf(filename,"%s",argv[1]) ;
		cout << endl << "filename " << filename ;
	}



	nfs_dat.open(nfsdat,ios::in) ;


	nfs_dat >> M >> M ;
	nfs_dat >> fL ;
	nfs_dat >> SZR >> SZA >> SZC ;
	nfs_dat >> Ha >> Hb ;
	nfs_dat >> Bstart >> Bend ;
	nfs_dat >> SieveUnit ;
	nfs_dat >> LpvLimR >> LpvLimR2 ;
	nfs_dat >> LpvLimA >> LpvLimA2 ;
	nfs_dat >> nFF >> nPF >> nFP  >> nPP >> nPPF >> nFPP >> nPP_P >> nP_PP >> nPPPP ;
	nfs_dat >> nFailsR >>nFailsA >> nSieveOdd >> nSieveEven ;
	nfs_dat.close() ;

	LcF=fL[deg(fL)] ;


	SetRationalPrimes2(SZR,PrimesR) ;
	SetAlgebraicPrimes2(SZA,SZC,PrimesA,RootA) ;
	if( argc<2 ) {
		CheckData(SZR, SZA,
				 PrimesR,
				PrimesA,
				 RootA
	         ) ;
	}
	else {

		if( access(filename,0)!=0 ) {
			cout << endl << "Error( file does not exist)" ;
			goto RET ;
		}
		is.open(filename,ios::in) ;
		if( is.bad() ) {
			cout << endl << "Error( file does not exist)" ;
			goto RET ;
		}


		CheckData(
				is,
				M,
					SZR, SZA,
		    	LpvLimR,LpvLimA,
				 PrimesR,
				PrimesA,
				RootA ) ;
		is.close() ;
	}
RET:
	delete [] PrimesR ;
	delete [] PrimesA ;
	delete [] RootA ;
	return ;


}



void SetRationalPrimes2(unsigned long& SZR,unsigned long*& Primes)
{
	unsigned long p ;
	SZR=0 ;
	nfs_rfb.open(nfsrfb,ios::binary|ios::in) ;
	if( nfs_rfb.bad() ) {
		cerr << endl << "Error : could not open file " << nfs_rfb ;
		Error(file not found) ;
	}
	for(;;) {
		nfs_rfb.read((char*)&p,sizeof(unsigned long)) ;
		if( nfs_rfb.eof() ) break ;
		SZR++ ;
	}
	nfs_rfb.close() ;

	Primes=new unsigned long[SZR] ;
	nfs_rfb.open(nfsrfb,ios::binary|ios::in) ;
	if( nfs_rfb.bad() ) {
		cerr << endl << "Error : could not open file " << nfs_rfb ;
		Error(file not found) ;
	}
	nfs_rfb.read((char*)Primes,SZR*sizeof(unsigned long)) ;
	nfs_rfb.close() ;
#if 1
for( unsigned long j=0 ; j<SZR ; j++ ) {
	if( Primes[j]==0 ) {
		 cout << endl << "j " << j ;
		 cout << endl <<" SZR " <<SZR ;
		Error( Primes[j]==0) ;
	}
}
#endif

	nfs_rfb.close() ;
}





//////////////////////////////////////////////////////////////////////
//
//	Read Algebraic Primes from File
//

void SetAlgebraicPrimes2(unsigned long& SZA,unsigned long& SZC,unsigned long*& PrimesA,unsigned long*& RootA)
{
	unsigned long p ;
	unsigned long j ;
	unsigned long s ;
	Mint p2 ;
//	unsigned long SZAC ;
	SZA=0 ;
//	SZC=0 ;
	nfs_afb.open(nfsafb,ios::binary|ios::in) ;
	if( nfs_afb.bad() ) {
		cerr << endl << "Error : could not open file " << nfsafb ;
		Error(file not found) ;
	}
	for(;;) {
		nfs_afb.read((char*)&p,sizeof(p)) ;
		if( nfs_afb.eof() ) break ;
		nfs_afb.read((char*)&s,sizeof(s)) ;
		if( p>Maxlim ) break ;
		SZA++ ;
	}
	for( SZC=1 ;;) {
		nfs_afb.read((char*)&p,sizeof(p)) ;
		if( nfs_afb.eof() ) break ;
		nfs_afb.read((char*)&s,sizeof(s)) ;
//		  if( p>Maxlim ) break ;
		SZC++ ;
	}
	nfs_afb.close() ;

//	SZAC=SZA+SZC ;
	PrimesA=new unsigned long[SZA+SZC] ;
	RootA=new unsigned long[SZA+SZC] ;
	nfs_afb.open(nfsafb,ios::binary|ios::in) ;
	if( nfs_afb.bad() ) {
		cerr << endl << "Error : could not open file " << nfsafb ;
		Error(file not found) ;
	}

//	nLcFPrimes=0 ;
	for( j=0 ; j<SZA ; j++ ) {
		nfs_afb.read((char*)&p,sizeof(p)) ;
		if( nfs_afb.eof() ) break ;
		nfs_afb.read((char*)&s,sizeof(s)) ;
//cout << endl << p << " " << s ;
		if( p==0 ) p=s ;	  // СȤθߴΤ
		if( LcF%p!=0 ) {
			RootA[j]=s ;
			PrimesA[j]=p ;
		}
		else {
			RootA[j]=p ;
			PrimesA[j]=0 ;
		}
	}
//	SZA=j ;

	for( j=0 ; j<SZC ; j++ ) {						// set characters
		nfs_afb.read((char*)&p,sizeof(p)) ;
		if( nfs_afb.eof() ) break ;
		nfs_afb.read((char*)&s,sizeof(s)) ;
		RootA[SZA+j]=s ;									// RootA= (root of f(x) mod p )
		PrimesA[SZA+j]=p ;
	}
//	SZC=j ;
	nfs_afb.close() ;
//	SZC=SZAC-SZA ;
}


void SetCharacters(unsigned long& SZC,unsigned long* PrimesC,unsigned long* RootC)
{
	unsigned long p ;
	unsigned long SZA ;
	unsigned long j ;
	unsigned long s ;
	Mint p2 ;
	SZA=0 ;
//	SZC=0 ;
	nfs_afb.open(nfsafb,ios::binary|ios::in) ;
	if( nfs_afb.bad() ) {
		cerr << endl << "Error : could not open file " << nfsafb ;
		Error(file not found) ;
	}
	for(;;) {
		nfs_afb.read((char*)&p,sizeof(p)) ;
		nfs_afb.read((char*)&s,sizeof(s)) ;
//		  if( nfs_afb.eof() ) break ;
		if( p>Maxlim ) break ;
		SZA++ ;
	}
	for( SZC=1 ;;) {
		nfs_afb.read((char*)&p,sizeof(p)) ;
		nfs_afb.read((char*)&s,sizeof(s)) ;
		if( nfs_afb.eof() ) break ;
//		  if( p>Maxlim ) break ;
		SZC++ ;
	}
	nfs_afb.close() ;

//	PrimesA=new unsigned long[SZA+SZC] ;
//	RootA=new unsigned long[SZA+SZC] ;
	nfs_afb.open(nfsafb,ios::binary|ios::in) ;
	if( nfs_afb.bad() ) {
		cerr << endl << "Error : could not open file " << nfsafb ;
		Error(file not found) ;
	}

	nLcFPrimes=0 ;
	for( j=0 ; j<SZA ; j++ ) {
		nfs_afb.read((char*)&p,sizeof(p)) ;
		nfs_afb.read((char*)&s,sizeof(s)) ;
/*****************
		if( p==0 ) p=s ;	  // СȤθߴΤ
		if( LcF%p!=0 ) {
			RootA[j]=s ;
			PrimesA[j]=p ;
		}
		else {
			RootA[j]=p ;
			PrimesA[j]=0 ;
		}
//		  if( p==0 ) { logPA[j]=0 ; nLcFPrimes++ ; }	  // s is a LcF prime
//		  else logPA[j]=log(p)*Scale ;
******************/
	}

	for( j=0 ; j<SZC ; j++ ) {						 // set characters
		nfs_afb.read((char*)&p,sizeof(p)) ;
		nfs_afb.read((char*)&s,sizeof(s)) ;
		RootC[j]=s ;									// RootA= (root of f(x) mod p )
		PrimesC[j]=p ;
	}
	nfs_afb.close() ;
}



Mint Norm(long A,unsigned long B,PolyL& fL)
{
	long j ;
	static Mint V ;
	unsigned long k(0) ;
	(V=fL[deg(fL)])*=A	;
	_fx=B ;
	for( j=deg(fL)-1 ; j>0 ; j-- ) {
		if( (++k)&1 ) (V-=fL[j]*_fx)*=A ;
		else		  (V+=fL[j]*_fx)*=A ;
		_fx*=B ;
	}
	if( ++k&1 ) V-=fL[0]*_fx ;
	else V+=fL[0]*_fx ;
	return V ;
}


Mint Norm(long A,unsigned long B,PolyM& fL)
{

	static Mint V ;
//	V=0 ;
	long j ;
	unsigned long k(0) ;
//	bool odd(false) ;
	(V=fL[deg(fL)])*=A	;

	for( j=deg(fL)-1 ; j>0 ; j-- ) {
		if( (++k)&1 ) (V-=fL[j]*power(B,k))*=A ;
		else (V+=fL[j]*power(B,k))*=A ;
//		sign++ ;
//		odd=~odd ;
	}

	if( ++k&1 ) V-=fL[0]*power(B,k) ;
	else			V+=fL[0]*power(B,k) ;

	return V ;
}

Mint Norm(Mint& A,unsigned long B,PolyM& fL)
{
	static Mint V ;
//	V=0 ;
	long j ;
	unsigned long k(0) ;
//	bool odd(false) ;
	(V=fL[deg(fL)])*=A	;

	for( j=deg(fL)-1 ; j>0 ; j-- ) {
	if( (++k)&1 ) (V-=fL[j]*power(B,k))*=A ;
	else (V+=fL[j]*power(B,k))*=A ;
//		sign++ ;
//		odd=~odd ;
	}
	if( ++k&1 ) V-=fL[0]*power(B,k) ;
	else			V+=fL[0]*power(B,k) ;
	return V ;
}

/***********
Mint Norm(long A,unsigned long B,PolyM& fL)
{
//	Mint MB(B) ;
//	Mint MA(A) ;
	static Mint V ;
	V=0 ;
	long j ;
	long sign(1) ;
	for( j=deg(fL) ; j>=0 ; j-- ) {
	if( sign>0 ) V+=fL[j]*power(A,j)*power(B,deg(fL)-j) ;	 // (-1)^j*c_j*A^j*(-B)^(d-j)
	else		 V-=fL[j]*power(A,j)*power(B,deg(fL)-j) ;
	sign=-sign ;
	}
	return V ;
}
***************/


void CheckData(unsigned long SZR,unsigned long SZA,
				unsigned long* PrimesR,
				unsigned long* PrimesA,
				unsigned long* RootA)

{
	unsigned long nFF,nPF,nFP,nPP,nFPP,nPPF,nP_PP,nPP_P,nPPPP ;
//	long j,k ;
	long a ;
//	unsigned long r2 ;
	unsigned long b ;
	Mint q ;
	unsigned long* v2 ;
	v2=new unsigned long[(SZR+SZA+31)/32] ;
	nFF=nPF=nFP=nPP=nFPP=nPPF=nP_PP=nPP_P=nPPPP=0 ;

	nfs_ff.open(nfsff,ios::in|ios::binary) ;	// 410
	for(;;) {
		nfs_ff.read((char*)&a,sizeof(a)) ;
		if( nfs_ff.eof() ) break ;
		nfs_ff.read((char*)&b,sizeof(b)) ;
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		q=(a+b*M) ;
		nFF++ ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << " FF(R) " << a << " " << b <<" " << q  ;
Error(FF(R)) ;
			q=(a+b*M) ;
			BitDecompR(SZR,PrimesR,q,v2) ;

		}
		q=Norm(a,b,fL) ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " FF(A) " << a << " " << b <<" " << q  ;
cout << endl << rho(q) ;
cout << "PrimesA " << PrimesA[0] <<" " <<PrimesA[1] <<" " <<PrimesA[2] <<" " << PrimesA[3] <<" "
<< PrimesA[4] <<" ";
cout << endl << "PmaxA" << PrimesA[SZA-1] ;
Error(FF(A)) ;
			q=Norm(a,b,fL) ;
			BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ;
		}

	}
	nfs_ff.close() ;
cout << endl << "end check FF " ;



	Rr1=Rr2=Ra1=1 ;
	nfs_fp.open(nfsfp,ios::in|ios::binary) ;	// 410
	for(;;) {
		nfs_fp.read((char*)&a,sizeof(a)) ;
		if( nfs_fp.eof() ) break ;
		nfs_fp.read((char*)&b,sizeof(b)) ;
		nfs_fp.read((char*)&Ra2,sizeof(Ra2)) ;			// algebraic large prime
//		if( r1==0 ) continue ;
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;

		q=(a+b*M) ;
		nFP++ ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			q=(a+b*M) ;
			BitDecompR(SZR,PrimesR,q,v2) ;
			cout << " FP(R) " << a << " " << b	<< " " << q ;
			cout << " Ra2 " << Ra2 ;

			Error(Check data FP(R)) ;

		}
		if( prmdiv(Ra2)!=1 ) Error(not prime) ;
		q=Norm(a,b,fL)/Ra2 ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " FP(A) " << a << " " << b	<<" " << q ;
			cout << " Ra2 " << Ra2 ;
	  q=Norm(a,b,fL)/Ra2 ;
//BitDecompA(SZA,a,b,q) ;
			Error(Check data FP(A)) ;

		}
		cout << endl
			<< setw(10) << setfill(' ') << a
			<< setw(10) << setfill(' ') << b
			<< setw(10) << setfill(' ') << Rr1
			<< setw(10) << setfill(' ') << Rr2
			<< setw(10) << setfill(' ') << Ra1
			<< setw(10) << setfill(' ') << Ra2 ;
	}
	nfs_fp.close() ;
cout << endl << "end check stage FP " ;

	Rr1=Rr2=Ra1=Ra2=1 ;
	nfs_pf.open(nfspf,ios::in|ios::binary) ;
	for(;;) {
		nfs_pf.read((char*)&a,sizeof(a)) ;
		if( nfs_pf.eof() ) break ;
		nfs_pf.read((char*)&b,sizeof(b)) ;
		nfs_pf.read((char*)&Rr2,sizeof(Rr2)) ;			// algebraic large prime
//		if( r1==0 ) continue ;
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		if( prmdiv(Rr2)!=1 ) Error(not prime) ;
		q=(a+b*M)/Rr2 ;
		nPF++ ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << " PF(R) " << a << " " << b	<< " Rr2 " << Rr2;
			Error(PF(R)) ;
			q=(a+b*M)/Rr2 ;

		}
		q=Norm(a,b,fL) ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " PF(A) " << a << " " << b	;
			Error(PF(A)) ;
cout << endl << q ;
		q=Norm(a,b,fL) ;
//		  BitDecompA(SZA,a,b,q) ;

		}
		cout << endl
			<< setw(10) << setfill(' ') << a
			<< setw(10) << setfill(' ') << b
			<< setw(10) << setfill(' ') << Rr1
			<< setw(10) << setfill(' ') << Rr2
			<< setw(10) << setfill(' ') << Ra1
			<< setw(10) << setfill(' ') << Ra2 ;

	}
	nfs_pf.close() ;
cout << endl << "end check stage PF " ;

	Rr1=Rr2=Ra1=Ra2=1 ;
	nfs_pp.open(nfspp,ios::in|ios::binary) ;	// 410
	for(;;) {
		nfs_pp.read((char*)&a,sizeof(a)) ;
		if( nfs_pp.eof() ) break ;
		nfs_pp.read((char*)&b,sizeof(b)) ;
		nfs_pp.read((char*)&Rr2,sizeof(Rr2)) ;			// algebraic large prime
		nfs_pp.read((char*)&Ra2,sizeof(Ra2)) ;			// algebraic large prime
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		q=(a+b*M)/Rr2 ;
		nPP++ ;
		if( prmdiv(Rr2)!=1 ) Error(not prime) ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << " P-P(R) " << a << " " << b	 ;
			q=(a+b*M)/Rr2 ;

		}
		if( prmdiv(Ra2)!=1 ) Error(not prime) ;
		q=Norm(a,b,fL)/Ra2 ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " P-P(A) " << a << " " << b	 ;
//cout << endl << q ;
			q=Norm(a,b,fL)/Ra2 ;
			BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ;

		}
		cout << endl
			<< setw(10) << setfill(' ') << a
			<< setw(10) << setfill(' ') << b
			<< setw(10) << setfill(' ') << Rr1
			<< setw(10) << setfill(' ') << Rr2
			<< setw(10) << setfill(' ') << Ra1
			<< setw(10) << setfill(' ') << Ra2 ;

	}
	nfs_pp.close() ;
cout << endl << "end check PP  " ;


	Rr1=Rr2=Ra1=Ra2=1 ;
	nfs_ppf.open(nfsppf,ios::in|ios::binary) ;	// 410
	for(;;) {
		nfs_ppf.read((char*)&a,sizeof(a)) ;
		if( nfs_ppf.eof() ) break ;
		nfs_ppf.read((char*)&b,sizeof(b)) ;
		nfs_ppf.read((char*)&Rr1,sizeof(Rr1)) ;			// algebraic large prime
		nfs_ppf.read((char*)&Rr2,sizeof(Rr2)) ;			// algebraic large prime
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		q=(a+b*M)/Rr1/Rr2 ;
		nPPF++ ;
		if( prmdiv(Rr1)!=1 ) Error(not prime) ;
		if( prmdiv(Rr2)!=1 ) Error(not prime) ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << " PP-F(R) " << a << " " << b	 ;
			q=(a+b*M)/Rr1 ;

		}
		q=Norm(a,b,fL) ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " PP-F(A) " << a << " " << b	 ;
//cout << endl << q ;
			q=Norm(a,b,fL) ;
			BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ;

		}
		cout << endl
			<< setw(10) << setfill(' ') << a
			<< setw(10) << setfill(' ') << b
			<< setw(10) << setfill(' ') << Rr1
			<< setw(10) << setfill(' ') << Rr2
			<< setw(10) << setfill(' ') << Ra1
			<< setw(10) << setfill(' ') << Ra2 ;

	}
	nfs_ppf.close() ;
cout << endl << "end check PPF  " ;


	Rr1=Rr2=Ra1=Ra2=1 ;
	nfs_fpp.open(nfsfpp,ios::in|ios::binary) ;	// 410
	for(;;) {
		nfs_fpp.read((char*)&a,sizeof(a)) ;
		if( nfs_fpp.eof() ) break ;
		nfs_fpp.read((char*)&b,sizeof(b)) ;
		nfs_fpp.read((char*)&Ra1,sizeof(Ra1)) ;			// algebraic large prime
		nfs_fpp.read((char*)&Ra2,sizeof(Ra2)) ;			// algebraic large prime
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		q=(a+b*M) ;
		nFPP++ ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << " F-PP(R) " << a << " " << b	 ;
			q=(a+b*M)/Rr1 ;

		}
if( prmdiv(Ra1)!=1 ) Error(not prime) ;
if( prmdiv(Ra2)!=1 ) Error(not prime) ;
		q=Norm(a,b,fL)/Ra1/Ra2 ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " F-PP(A) " << a << " " << b	 ;
//cout << endl << q ;
			q=Norm(a,b,fL)/Ra1/Ra2 ;
			BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ;

		}
		cout << endl
			<< setw(10) << setfill(' ') << a
			<< setw(10) << setfill(' ') << b
			<< setw(10) << setfill(' ') << Rr1
			<< setw(10) << setfill(' ') << Rr2
			<< setw(10) << setfill(' ') << Ra1
			<< setw(10) << setfill(' ') << Ra2 ;

	}
	nfs_fpp.close() ;
cout << endl << "end check FPP  " ;

	Rr1=Rr2=Ra1=Ra2=1 ;
	nfs_p_pp.open(nfsp_pp,ios::in|ios::binary) ;	// 410
	for(;;) {
		nfs_p_pp.read((char*)&a,sizeof(a)) ;
		if( nfs_p_pp.eof() ) break ;
		nfs_p_pp.read((char*)&b,sizeof(b)) ;
		nfs_p_pp.read((char*)&Rr2,sizeof(Rr2)) ;			// algebraic large prime
		nfs_p_pp.read((char*)&Ra1,sizeof(Ra1)) ;			// algebraic large prime
		nfs_p_pp.read((char*)&Ra2,sizeof(Ra2)) ;			// algebraic large prime
		if( prmdiv(Rr1)!=1 ) Error(not prime) ;
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		q=(a+b*M)/Rr2 ;
		nP_PP++ ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << " P-PP(R) " << a << " " << b	 ;
			q=(a+b*M)/Rr2 ;

		}
		if( prmdiv(Ra1)!=1 ) Error(not prime) ;
		if( prmdiv(Ra2)!=1 ) Error(not prime) ;
		q=Norm(a,b,fL)/Ra1/Ra2 ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " P-PP(A) " << a << " " << b	 ;
//cout << endl << q ;
			q=Norm(a,b,fL)/Ra1/Ra2 ;
			BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ;

		}
		cout << endl
			<< setw(10) << setfill(' ') << a
			<< setw(10) << setfill(' ') << b
			<< setw(10) << setfill(' ') << Rr1
			<< setw(10) << setfill(' ') << Rr2
			<< setw(10) << setfill(' ') << Ra1
			<< setw(10) << setfill(' ') << Ra2 ;

	}
	nfs_p_pp.close() ;
cout << endl << "end check P_PP  " ;

	Rr1=Rr2=Ra1=Ra2=1 ;
	nfs_pp_p.open(nfspp_p,ios::in|ios::binary) ;	// 410
	for(;;) {
		nfs_pp_p.read((char*)&a,sizeof(a)) ;
		if( nfs_pp_p.eof() ) break ;
		nfs_pp_p.read((char*)&b,sizeof(b)) ;
		nfs_pp_p.read((char*)&Rr1,sizeof(Rr1)) ;			// algebraic large prime
		nfs_pp_p.read((char*)&Rr2,sizeof(Rr2)) ;			// algebraic large prime
		nfs_pp_p.read((char*)&Ra2,sizeof(Ra2)) ;			// algebraic large prime
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		q=(a+b*M)/Rr1/Rr2 ;
		nPP_P++ ;
		if( prmdiv(Rr1)!=1 ) Error(not prime) ;
		if( prmdiv(Rr2)!=1 ) Error(not prime) ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << " PP_P(R) " << a << " " << b	 ;
			q=(a+b*M)/Rr1/Rr2 ;

		}
		q=Norm(a,b,fL)/Ra2 ;
		if( prmdiv(Ra2)!=1 ) Error(not prime) ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " PP_P(A) " << a << " " << b	 ;
//cout << endl << q ;
			q=Norm(a,b,fL)/Ra1 ;
			BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ;

		}
		cout << endl
			<< setw(10) << setfill(' ') << a
			<< setw(10) << setfill(' ') << b
			<< setw(10) << setfill(' ') << Rr1
			<< setw(10) << setfill(' ') << Rr2
			<< setw(10) << setfill(' ') << Ra1
			<< setw(10) << setfill(' ') << Ra2 ;

	}
	nfs_pp_p.close() ;
cout << endl << "end check PP_P  " ;

	Rr1=Rr2=Ra1=Ra2=1 ;
	nfs_pppp.open(nfspppp,ios::in|ios::binary) ;	// 410
	for(;;) {
		nfs_pppp.read((char*)&a,sizeof(a)) ;
		if( nfs_pppp.eof() ) break ;
		nfs_pppp.read((char*)&b,sizeof(b)) ;
		nfs_pppp.read((char*)&Rr1,sizeof(Rr1)) ;			// algebraic large prime
		nfs_pppp.read((char*)&Rr2,sizeof(Rr2)) ;			// algebraic large prime
		nfs_pppp.read((char*)&Ra1,sizeof(Ra1)) ;			// algebraic large prime
		nfs_pppp.read((char*)&Ra2,sizeof(Ra2)) ;			// algebraic large prime
		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		if( prmdiv(Rr1)!=1 ) Error(not prime) ;
		if( prmdiv(Rr2)!=1 ) Error(not prime) ;
		q=(a+b*M)/Rr1/Rr2 ;
		nPPPP++ ;
		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << " PP-PP(R) " << a << " " << b	 ;
			q=(a+b*M)/Rr1/Rr2 ;
		}
		if( prmdiv(Ra1)!=1 ) Error(not prime) ;
		if( prmdiv(Ra2)!=1 ) Error(not prime) ;
		q=Norm(a,b,fL)/Ra1/Ra2 ;
		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << " PP-PP(A) " << a << " " << b	 ;
//cout << endl << q ;
			q=Norm(a,b,fL)/Ra1/Ra2 ;
			BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ;

		}
		cout << endl
			<< setw(10) << setfill(' ') << a
			<< setw(10) << setfill(' ') << b
			<< setw(10) << setfill(' ') << Rr1
			<< setw(10) << setfill(' ') << Rr2
			<< setw(10) << setfill(' ') << Ra1
			<< setw(10) << setfill(' ') << Ra2 ;

	}
	nfs_pppp.close() ;
cout << endl << "end check PPPP  " ;
	cout << endl << nFF << " " << nPF << " " << nFP << " " << nPP <<" "
			<< nPPF << " " << nFPP << " " << nPP_P << " " << nP_PP << " " << nPPPP ;

   delete [] v2 ;
}

void CheckData(ifstream& is,Mint& M,
				unsigned long SZR,unsigned long SZA,
				unsigned long LpvLimR,
				unsigned long LpvLimA,
				unsigned long* PrimesR,
				unsigned long* PrimesA,
				unsigned long* RootA
				)

{

	unsigned long nFF,nPF,nFP,nPP,nFPP,nPPF,nP_PP,nPP_P,nPPPP ;
	long a ;
	unsigned long b ;
	Mint q ;
	unsigned long* v2 ;
	v2=new unsigned long[(SZR+SZA+31)/32] ;
	nFF=nPF=nFP=nPP=nFPP=nPPF=nP_PP=nPP_P=nPPPP=0 ;
#if 1
	cout << endl << " M " << M ;
	cout << endl << "SAR SZA " << SZR << " " << SZA ;
	cout << endl << "PrimesR " << PrimesR[0] << " " << PrimesR[1] << " " <<  PrimesR[2] << " " <<  PrimesR[3] ;
	cout << endl << "PrimesA " << PrimesA[0] << " " << PrimesA[1] << " " <<  PrimesA[2] << " " <<  PrimesA[3] ;
	cout << endl << "RootR " << RootA[0] << " " << RootA[1] << " " <<  RootA[2] << " " <<  RootA[3] ;
#endif
//	cout << endl << "fL " << fL ;
	for(;;) {
		is >> a	;
		if( is.eof() ) break ;
		is >> b ;
		is >> Rr1 ;
		is >> Rr2 ;
		is >> Ra1 ;
		is >> Ra2 ;

		cout << endl
		<< setw(10) << setfill(' ') << a
		<< setw(10) << setfill(' ') << b
		<< setw(10) << setfill(' ') << Rr1
		<< setw(10) << setfill(' ') << Rr2
		<< setw(10) << setfill(' ') << Ra1
		<< setw(10) << setfill(' ') << Ra2 ;
		if( gcd(a,b)!=1 ) {

		  cout << "(gcd(a,b)!=1" ;
		}

//		if( gcd(a,b)!=1 ) Error(gcd(a,b)!=1) ;
		q=(a+b*M)/Rr1/Rr2 ;
		if( Rr1>Rr2 ) {
			Error( Rr1>Rr2 ) ;
		}
		if( Rr1!=1 ) {
			if( Rr1<PmaxR ) Error( Rr1<PmaxR) ;
			if( Rr1>LpvLimR ) Error(Rr1>LpvLimR) ;
		}
		if( Rr2!=1 ) {
			if( Rr2<PmaxR ) Error( Rr2<PmaxR) ;
			if( Rr2>LpvLimR ) Error(Rr2>LpvLimR) ;
		}

		if( !BitDecompR(SZR,PrimesR,q,v2) ) {
			cout << endl <<  a << " " << b <<" " << q  ;
			Error(FF(R)) ;
			q=(a+b*M) ;
			BitDecompR(SZR,PrimesR,q,v2) ;

		}
//cout << " R " ;
		q=Norm(a,b,fL)/Ra1/Ra2 ;
//cout << endl << q ;
		if( Ra1>Ra2 ) {
			Error( Ra1>Ra2 ) ;
		}
		if( Ra1!=1 ) {
			if( Ra1<PmaxA ) Error( Ra1<PmaxA) ;
			if( Ra1>LpvLimA ) Error(Ra1>LpvLimA) ;
		}
		if( Ra2!=1 ) {
			if( Ra2<PmaxA ) Error( Ra2<PmaxA) ;
			if( Ra2>LpvLimA ) Error(Ra2>LpvLimA) ;
		}

		if( !BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ) {
			cout << endl <<  a << " " << b <<" " << q  ;
			Error(A) ;
// 			cout << endl << rho(q) ;
			q=Norm(a,b,fL) ;
			BitDecompA(SZA,PrimesA,RootA,a,b,q,v2) ;
		}
//cout <<  " A " ;
		if( Rr2==1 ) {
			if( Ra2==1 ) nFF++ ;
			else if( Ra1==1 ) nFP++ ;
			else           nFPP++ ;
		}
		else if( Rr1==1 ) {
			if( Ra2==1 ) nPF++ ;
			else if( Ra1==1 ) nPP++ ;
			else           nP_PP++ ;
		}
		else {
			if( Ra2==1 ) nPPF++ ;
			else if(Ra1==1 ) nPP_P++ ;
			else           nPPPP++ ;
		}
	}

	cout << endl << nFF << " " << nPF << " " << nFP << " " << nPP <<" "
			<< nPPF << " " << nFPP << " " << nPP_P << " " << nP_PP << " " << nPPPP ;

	delete [] v2 ;

}
