//
//  Copyright (C) by S.Tomabechi 1994,1997
//  All rights reserved.
//
//  read, write multiple precision numbers as binary data
//
//  nDigit      4 byte          : number of digits
//  fDigit      4 byte          : #digits of fractiona part
//  signature   4 byte          : 1 or -1
//  digits      4 byte * nDigit : digit[0],digit[1],...,digit[nDigit-1]
//
#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include <iostream.h>

void write(ostream& os,const Mint& n)
{
  unsigned long sign=n.nDim&_NEGATIVE_ ;
  os.write((char*)&n.nDigit,sizeof(n.nDigit)) ;
  os.write((char*)&n.fDigit,sizeof(n.fDigit)) ;
  os.write((char*)&sign,sizeof(sign)) ;
  if( n.nDigit!=0 )
    os.write((char*)n.digit,sizeof(unsigned long)*long(n.nDigit)) ;
}

void read(istream& is,Mint& n)
{
  long ndigit,fdigit ;
  unsigned long sign ;
  is.read((char*)&ndigit,sizeof(n.nDigit)) ;
  is.read((char*)&fdigit,sizeof(n.fDigit)) ;
  is.read((char*)&sign,sizeof(sign)) ;
  if( ndigit!=0 ) {
    if( ndigit>n.ndim() ) n.allocate(ndigit) ;       // enough memory ?
    is.read((char*)n.digit,sizeof(unsigned long)*long(ndigit)) ;
  }
#ifdef WIN32
  __asm {
#   ifdef __BORLANDC__
    mov  esi,n
    mov  eax,sign
    or   dword ptr [esi.nDim],eax
    mov  eax,ndigit
    mov  dword ptr [esi.nDigit],eax
    mov  eax,fdigit
    mov  dword ptr [esi.fDigit],eax

#   else
    mov  esi,n
    mov  eax,sign
    or   dword ptr [esi+NDIM],eax
    mov  eax,ndigit
    mov  dword ptr [esi+NDIGIT],eax
    mov  eax,fdigit
    mov  dword ptr [esi+FDIGIT],eax
#   endif
  }
#else
  (n.nDim&=_DIGITS_)|=sign ;
  n.nDigit=ndigit ;
  n.fDigit=fdigit ;
#endif


#ifdef _MEMMAN_DEBUG
n.check(__FILE__,__LINE__) ;
#endif
}
