//
//  Copyright (C) by S.Tomabechi  1997
//  All rights reserved.
//
//  Given a positive integer n>1, this algorithm test whether n is
//  of the form p^k with prime p or not, and if it is, output the
//  prime p.
//
#include "Mint.hpp"
#include <iostream.h>

#if 0
// ڿͤꤷ Rabin-Miller test
static bool Rabin1(const Mint& N,Mint& m)
{
  unsigned long a=time(NULL) ;
  Mint b ;
  Mint q ;
  long e,t ;
  unsigned long iloop ;

                          // trial division when N<2^32
  if( N.ndigit()<2 ) return prmdiv(N)==1 ;

                          // even ?
  if( Even(N) )  return N==2 ;

  q=N-1 ;
  t=Val2(q) ;             // 2^t || q   gcd(2,q/(2^t))=1
  if( t!=0 ) q>>=t ;      // divide by 2^t

//  for( iloop=maxloop ; (--iloop)>0 ; ) {

//    do {
//      m=irandom(a) ;
//    } while( m<=1 ) ;

    b=apower(m,q,N) ;  // m^q mod N

    e=0 ;
//    if( b==1 ) continue ;    // Fermat's little theorem
    if( b==1 ) return true ;

    while( b!=1 && b!=-1 && e<=t-2 ) {
      b=square(b)^N ;        // operator^() : the least absolute residue
      e++ ;
    }

    if( b!=-1 ) return false ;

//  }
  return true ;
}
#endif



bool powerdetect(const Mint& n,Mint& p,unsigned long& e)
{
    Mint nn,q,d ;
    Mint a ;
    Mint q_1,b ;
    long t,k ;

    if( Even(n) ) p=2 ;                   // ʤ 2 ǳäƻ
    else {
        q=n ;

        for(;;) {

            for(;;) {
                do {                         // generate witness
                    a=irandom() ;
//cout << " a " << a ;
                } while( a<=1 ) ;

                {           // Rabin-Miller test
                if( ndigit(q)<2 ) {         // trial division
                    if( prmdiv(q)==1 ) {
                        p=q ;
                        break ;
//                      return true ;
                    }
                }
                q_1=q-1 ;
                t=Val2(q_1) ;             // 2^t || q   gcd(2,q/(2^t))=1
                if( t!=0 ) q_1>>=t ;      // divide by 2^t

                b=apower(a,q_1,q) ;  // a^q mod N

//              e=0 ;
//    if( b==1 ) continue ;    // Fermat's little theorem
                if( b==1 ) {
                    p=q ;
//cout << endl << " break 1 " ;
                    break ;
                }
                k=0 ;
                while( b!=1 && b!=-1 && k<=t-2 ) {
                    b=square(b)^q ;        // operator^() : the least absolute residue
                    k++ ;
                }

                if( b!=-1 ) ;
                else {
                    p=q ;
//cout << endl << " break 2 " ;
                    break ;
                }
                }
//  }
//            return true ;
//        if( Rabin1(q,Mint(a)) )  {         // a : q ǿǤ뤳Ȥξڿ
//          p=q ;
//          break ;
//        }
//              d=a ;                       // ǿǤʤ
                d=gcd(power(a,q,q)-a,q) ;     // gcd(a^q-a,q)
//cout << " d " << d ;
                if( d==1 || d==q ) return false ;   // n is not a prime power
                else q=d ;
            }

  // Here p | n

            if( APRCL(p) ) break ;     // p ǿ ?
            q=p ;
        }
    }


// Here p is prime
Final_test:
    for( e=0,nn=n ; ;) {
        divide(nn,p,d,q) ;
        e++ ;
        if( q!=0 ) return false ;      // p dose not divide nn
        if( d==1 ) return true ;
        else nn=d ;
    }

}

#if 0
bool powerdetect(Mint& n,Mint& p,unsigned long& e)
{
  Mint nn,q,d ;
  unsigned long a ;

  if( Even(n) ) p=2 ;                   // ʤ 2 ǳäƻ
  else {
    q=n ;

    for(;;) {

      for(;;) {
        do {
          a=irandom() ;
//cout << " a " << a ;
        } while( a<=1 ) ;


        if( Rabin1(q,Mint(a)) )  {         // a : q ǿǤ뤳Ȥξڿ
          p=q ;
          break ;
        }
        d=a ;                       // ǿǤʤ
        d=gcd(power(d,q,q)-a,q) ;     // gcd(a^q-a,q)
cout << " d " << d ;
        if( d==1 || d==q ) return false ;   // n is not a prime power
        else q=d ;
      }

  // Here p | n
      if( APRCL(p) ) break ;     // p ǿ ?
      q=p ;
    }
  }


// Here p is prime
Final_test:
   for( e=0,nn=n ; ;) {
     divide(nn,p,d,q) ;
     e++ ;
     if( q!=0 ) return false ;      // p dose not divide nn
     if( d==1 ) return true ;
     else nn=d ;
  }

}
#endif


#include <stdlib.h>
#include <iostream.h>

char* parse_in(::istream& is) ;
Mint parse(const char* str) ;
#ifdef POWDETECT_MAIN
int main(void)
{
    Mint n ;
    char* str ;
    Mint p ;
    unsigned long e ;

    for(;;) {
        str=parse_in(cin) ;
        n=parse(str) ;
        delete [] str ;
        if( n==0 ) break ;
        cout << endl << "n " << n ;
        if( powerdetect(n,p,e) ) {
            cout << endl << "found power " << p << "^" << e ;
        }
        else {
            cout << endl << "not found" ;
        }
    }

    return 1 ;

}
#endif